#ifndef _BLAS_H
#define _BLAS_H

#include "namesblas.h"
#include "long_integer.h"

complex              cdotc(integer *,complex *,integer *,complex *,integer *),
                     cdotu(integer *,complex *,integer *,complex *,integer *);
void                 caxpy(integer *,complex *,complex *,integer *,complex *,
			   integer *),
                     ccopy(integer *,complex *,integer *,complex *,integer *),
                     cgbmv(character *,integer *,integer *,integer *,integer *,
			   complex *, complex *,integer *,complex *,integer *,
			   complex *,complex *,integer *,ftnlen),
                     cgemm(character *,character *,integer *,integer *,
			   integer *,complex *,complex *,integer *,complex *,
			   integer *,complex *,complex *,integer *,ftnlen,
			   ftnlen),
                     cgemv(character *,integer *,integer *,complex *,complex *,
			   integer *,complex *,integer *,complex *,complex *,
			   integer *,ftnlen),
                     cgerc(integer *,integer *,complex *,complex *,integer *,
			   complex *,integer *,complex *,integer *),
                     cgeru(integer *,integer *,complex *,complex *,integer *,
			   complex *,integer *,complex *,integer *),
                     chbmv(character *,integer *,integer *,complex *,complex *,
			   integer *,complex *,integer *,complex *,complex *,
			   integer *,ftnlen),
                     chemm(character *,character *,integer *,integer *,
			   complex *,complex *,integer *,complex *,integer *,
			   complex *,complex *,integer *,ftnlen,ftnlen),
                     chemv(character *,integer *,complex *,complex *,integer *,
			   complex *,integer *,complex *,complex *,integer *,
			   ftnlen),
                     cher(character *,integer *,real *,complex *,integer *,
			  complex *,integer *,ftnlen),
                     cher2(character *,integer *,complex *,complex *,integer *,
			   complex *,integer *,complex *,integer *,ftnlen),
                     cher2k(character *,character *,integer *,integer *,
			    complex *,complex *,integer *,complex *,integer *,
			    real *,complex *,integer *,ftnlen,ftnlen),
                     cherk(character *,character *,integer *,integer *,real *,
			   complex *,integer *,real *,complex *,integer *,
			   ftnlen,ftnlen),
                     chpmv(character *,integer *,complex *,complex *,complex *,
			   integer *,complex *,complex *,integer *,ftnlen),
                     chpr(character *,integer *,real *,complex *,integer *,
			  complex *,ftnlen),
                     chpr2(character *,integer *,complex *,complex *,integer *,
			   complex *,integer *,complex *,ftnlen),
                     crotg(complex *,complex *,real *,complex *),
                     cscal(integer *,complex *,complex *,integer *),
                     csscal(integer *,real *,complex *,integer *),
                     cswap(integer *,complex *,integer *,complex *,integer *),
                     csymm(character *,character *,integer *,integer *,
			   complex *,complex *,integer *,complex *,integer *,
			   complex *,complex *,integer *,ftnlen,ftnlen),
                     csyr2k(character *,character *,integer *,integer *,
			    complex *,complex *,integer *,complex *,integer *,
			    complex *,complex *,integer *,ftnlen,ftnlen),
                     csyrk(character *,character *,integer *,integer *,
			   complex *,complex *,integer *,complex *,complex *,
			   integer *,ftnlen,ftnlen),
                     ctbmv(character *,character *,character *,integer *,
			   integer *,complex *,integer *,complex *,integer *,
			   ftnlen,ftnlen,ftnlen),
                     ctbsv(character *,character *,character *,integer *,
			   integer *,complex *,integer *,complex *,integer *,
			   ftnlen,ftnlen,ftnlen),
                     ctpmv(character *,character *,character *,integer *,
			   complex *,complex *,integer *,ftnlen,ftnlen,ftnlen),
                     ctpsv(character *,character *,character *,integer *,
			   complex *,complex *,integer *,ftnlen,ftnlen,ftnlen),
                     ctrmm(character *,character *,character *,character *,
			   integer *,integer *,complex *,complex *,integer *,
			   complex *,integer *,ftnlen,ftnlen,ftnlen,ftnlen),
                     ctrmv(character *,character *,character *,integer *,
			   complex *,integer *,complex *,integer *,ftnlen,
			   ftnlen,ftnlen),
                     ctrsm(character *,character *,character *,character *,
			   integer *,integer *,complex *,complex *,integer *,
			   complex *,integer *,ftnlen,ftnlen,ftnlen,ftnlen),
                     ctrsv(character *,character *,character *,integer *,
			   complex *,integer *,complex *,integer *,ftnlen,
			   ftnlen,ftnlen);

doubleprecision           dasum(integer *,doubleprecision *,integer *);
void                 daxpy(integer *,doubleprecision *,doubleprecision *,integer *,
			   doubleprecision *,integer *);
doubleprecision           dcabs1(doublecomplex *);
void                 dcopy(integer *,doubleprecision *,integer *,doubleprecision *,
			   integer *);
doubleprecision           ddot(integer *,doubleprecision *,integer *,doubleprecision *,
			  integer *);
void                 dgbmv(character *,integer *,integer *,integer *,integer *,
			   doubleprecision *,doubleprecision *,integer *,doubleprecision *,
			   integer *,doubleprecision *,doubleprecision *,integer *,
			   ftnlen),
                     dgemm(character *,character *,integer *,integer *,
			   integer *,doubleprecision *,doubleprecision *,integer *,
			   doubleprecision *,integer *,doubleprecision *,doubleprecision *,
			   integer *,ftnlen,ftnlen),
                     dgemv(character *,integer *,integer *,doubleprecision *,
			   doubleprecision *,integer *,doubleprecision *,integer *,
			   doubleprecision *,doubleprecision *,integer *,ftnlen),
                     dger(integer *,integer *,doubleprecision *,doubleprecision *,
			  integer *,doubleprecision *,integer *,doubleprecision *,
			  integer *);
doubleprecision           dnrm2(integer *,doubleprecision *,integer *);
void                 drot(integer *,doubleprecision *,integer *,doubleprecision *,
			  integer *,doubleprecision *,doubleprecision *),
                     drotg(doubleprecision *,doubleprecision *,doubleprecision *,
			   doubleprecision *),
                     dsbmv(character *,integer *,integer *,doubleprecision *,
			   doubleprecision *,integer *,doubleprecision *,integer *,
			   doubleprecision *,doubleprecision *,integer *,ftnlen),
                     dscal(integer *,doubleprecision *,doubleprecision *,integer *),
                     dspmv(character *,integer *,doubleprecision *,doubleprecision *,
			   doubleprecision *,integer *,doubleprecision *,doubleprecision *,
			   integer *,ftnlen),
                     dspr(character *,integer *,doubleprecision *,doubleprecision *,
			  integer *,doubleprecision *,ftnlen),
                     dspr2(character *,integer *,doubleprecision *,doubleprecision *,
			   integer *,doubleprecision *,integer *,doubleprecision *,
			   ftnlen),
                     dswap(integer *n,doubleprecision *,integer *,doubleprecision *,
			   integer *),
                     dsymm(character *,character *,integer *,integer *,
			   doubleprecision *,doubleprecision *,integer *,doubleprecision *,
			   integer *,doubleprecision *,doubleprecision *,integer *,
			   ftnlen,ftnlen),
                     dsymv(character *,integer *,doubleprecision *,doubleprecision *,
			   integer *,doubleprecision *,integer *,doubleprecision *,
			   doubleprecision *,integer *,ftnlen),
                     dsyr(character *,integer *,doubleprecision *,doubleprecision *,
			  integer *,doubleprecision *,integer *,ftnlen),
                     dsyr2(character *,integer *,doubleprecision *,doubleprecision *,
			   integer *,doubleprecision *,integer *,doubleprecision *,
			   integer *,ftnlen),
                     dsyr2k(character *,character *,integer *,integer *,
			    doubleprecision *,doubleprecision *,integer *,doubleprecision *,
			    integer *,doubleprecision *,doubleprecision *,integer *,
			    ftnlen,ftnlen),
                     dsyrk(character *,character *,integer *,integer *,
			   doubleprecision *,doubleprecision *,integer *,doubleprecision *,
			   doubleprecision *,integer *,ftnlen,ftnlen),
                     dtbmv(character *,character *,character *,integer *,
			   integer *,doubleprecision *,integer *,doubleprecision *,
			   integer *,ftnlen,ftnlen,ftnlen),
                     dtbsv(character *,character *,character *,integer *,
			   integer *,doubleprecision *,integer *,doubleprecision *,
			   integer *,ftnlen,ftnlen,ftnlen),
                     dtpmv(character *,character *,character *,integer *,
			   doubleprecision *,doubleprecision *,integer *,ftnlen,ftnlen,
			   ftnlen),
                     dtpsv(character *,character *,character *,integer *,
			   doubleprecision *,doubleprecision *,integer *,ftnlen,ftnlen,
			   ftnlen),
                     dtrmm(character *,character *,character *,character *,
			   integer *,integer *,doubleprecision *,doubleprecision *,
			   integer *,doubleprecision *,integer *,ftnlen,ftnlen,
			   ftnlen,ftnlen),
                     dtrmv(character *,character *,character *,integer *,
			   doubleprecision *,integer *,doubleprecision *,integer *,
			   ftnlen,ftnlen,ftnlen),
                     dtrsm(character *,character *,character *,character *,
			   integer *,integer *,doubleprecision *,doubleprecision *,
			   integer *,doubleprecision *,integer *,ftnlen,ftnlen,
			   ftnlen,ftnlen),
                     dtrsv(character *,character *,character *,integer *,
			   doubleprecision *,integer *,doubleprecision *,integer *,
			   ftnlen,ftnlen,ftnlen);
doubleprecision           dzasum(integer *,doublecomplex *,integer *),
                     dznrm2(integer *, doublecomplex *,integer *);

real                 sasum(integer *,real *,integer *),
                     scasum(integer *,complex *,integer *),
                     snrm2(integer *,real *,integer *),
                     scnrm2(integer *,complex *,integer *),
                     sdot(integer *,real *,integer *,real *,integer *);
extern void          sgemm(character *,character *,integer *,integer *, 
			   integer *,real *,real *,integer *,real *,integer *,
			   real *,real *,integer *,ftnlen,ftnlen),
                     sscal(integer *,real *,real *,integer *),
                     ssyr(character *,integer *,real *,real *,integer *,real *,
			  integer *,ftnlen),
                     stpsv(character *,character *,character *,integer *, 
			   real *,real *,integer *,ftnlen,ftnlen,ftnlen),
                     saxpy(integer *,real *,real *,integer *,real *,integer *),
                     sgemv(character *,integer *,integer *,real *,real *,
			   integer *,real *,integer *,real *,real *,integer *,
			   ftnlen),
                     sspmv(character *,integer *,real *,real *,real *,
			   integer *,real *,real *,integer *,ftnlen),
                     ssyr2(character *,integer *,real *,real *,integer *,
			   real *,integer *,real *,integer *,ftnlen),
                     strmm(character *,character *,character *,character *, 
			   integer *,integer *,real *,real *,integer *,real *, 
			   integer *,ftnlen,ftnlen,ftnlen,ftnlen),
                     sger(integer *,integer *,real *,real *,integer *,real *,
			  integer *,real *,integer *),
                     sspr(character *,integer *,real *,real *,integer *,real *,
			  ftnlen),
                     ssyr2k(character *u,character *,integer *,integer *, 
			    real *,real *,integer *,real *,integer *,real *,
			    real *,integer *,ftnlen,ftnlen),
                     strmv(character *,character *,character *,integer *,
			   real *,integer *,real *,integer *,ftnlen,ftnlen, 
			   ftnlen),
                     sspr2(character *,integer *,real *,real *,integer *,
			   real *,integer *,real *,ftnlen),
                     ssyrk(character *,character *,integer *,integer *,real *,
			   real *,integer *,real *,real *,integer *,ftnlen,
			   ftnlen),
                     strsm(character *,character *,character *,character *, 
			   integer *,integer *,real *,real *,integer *,real *, 
			   integer *,ftnlen,ftnlen,ftnlen,ftnlen),
                     scopy(integer *,real *,integer *,real *,integer *),
                     srot(integer *,real *,integer *,real *,integer *,real *,
			  real *),
                     sswap(integer *,real *,integer *,real *,integer *),
                     stbmv(character *,character *,character *,integer *n, 
			   integer *,real *,integer *,real *,integer *,ftnlen, 
			   ftnlen,ftnlen),
                     strsv(character *,character *,character *,integer *, 
			   real *,integer *,real *,integer *,ftnlen,ftnlen, 
			   ftnlen),
                     srotg(real *,real *,real *,real *),
                     ssymm(character *,character *,integer *,integer *,real *,
			   real *,integer *,real *,integer *,real *,real *, 
			   integer *,ftnlen,ftnlen),
                     stbsv(character *,character *,character *,integer *, 
			   integer *,real *,integer *,real *,integer *,ftnlen,
			   ftnlen,ftnlen),
                     sgbmv(character *,integer *,integer *,integer *,integer *,
			   real *,real *,integer *,real *,integer *,real *, 
			   real *,integer *,ftnlen),
                     ssbmv(character *,integer *,integer *,real *,real *, 
			   integer *,real *,integer *,real *,real *,integer *,
			   ftnlen),
                     ssymv(character *,integer *,real *,real *,integer *,
			   real *,integer *,real *,real *,integer *, ftnlen),
                     stpmv(character *,character *,character *,integer *, 
			   real *,real *,integer *,ftnlen,ftnlen,ftnlen);

doublecomplex        zdotc(doublecomplex *,integer *,doublecomplex *,integer *,
			   doublecomplex *,integer *),
                     zdotu(doublecomplex *,integer *,doublecomplex *,integer *,
			   doublecomplex *,integer *);
void                 zaxpy(integer *,doublecomplex *,doublecomplex *,integer *,
			   doublecomplex *,integer *),
                     zgemv(character *,integer *,integer *,doublecomplex *,
			   doublecomplex *,integer *,doublecomplex *,integer *,
			   doublecomplex *,doublecomplex *,integer *,ftnlen),
                     zher2(character *,integer *,doublecomplex *,
			   doublecomplex *,integer *,doublecomplex *,integer *,
			   doublecomplex *,integer *,ftnlen),
                     zscal(integer *,doublecomplex *,doublecomplex *,
			   integer *),
                     ztpmv(character *,character *,character *,integer *,
			   doublecomplex *,doublecomplex *,integer *,ftnlen,
			   ftnlen,ftnlen),
                     zcopy(integer *,doublecomplex *,integer *,doublecomplex *,
			   integer *),
                     zgerc(integer *,integer *,doublecomplex *,doublecomplex *,
			   integer *,doublecomplex *,integer *,doublecomplex *,
			   integer *),
                     zher2k(character *,character *,integer *,integer *, 
			    doublecomplex *,doublecomplex *,integer *, 
			    doublecomplex *,integer *,doubleprecision *, 
			    doublecomplex *,integer *,ftnlen,ftnlen),
                     zswap(integer *,doublecomplex *,integer *,doublecomplex *,
			   integer *),
                     ztpsv(character *,character *,character *,integer *, 
			   doublecomplex *,doublecomplex *,integer *,ftnlen, 
			   ftnlen,ftnlen),
                     zgeru(integer *,integer *,doublecomplex *,doublecomplex *,
			   integer *,doublecomplex *,integer *,doublecomplex *,
			   integer *),
                     zherk(character *,character *,integer *,integer *, 
			   doubleprecision *,doublecomplex *,integer *,doubleprecision *,
			   doublecomplex *,integer *,ftnlen,ftnlen),
                     zsymm(character *,character *,integer *,integer *, 
			   doublecomplex *,doublecomplex *,integer *, 
			   doublecomplex *,integer *,doublecomplex *, 
			   doublecomplex *,integer *,ftnlen,ftnlen),
                     ztrmm(character *,character *,character *,character *, 
			   integer *,integer *,doublecomplex *,doublecomplex *,
			   integer *,doublecomplex *,integer *,ftnlen,ftnlen,
			   ftnlen,ftnlen),
                     zhbmv(character *,integer *,integer *,doublecomplex *, 
			   doublecomplex *,integer *,doublecomplex *,integer *,
			   doublecomplex *,doublecomplex *,integer *,ftnlen),
                     zhpmv(character *,integer *,doublecomplex *, 
			   doublecomplex *,doublecomplex *,integer *, 
			   doublecomplex *,doublecomplex *,integer *,ftnlen),
                     zsyr2k(character *,character *,integer *,integer *, 
			    doublecomplex *,doublecomplex *,integer *,
			    doublecomplex *,integer *,doublecomplex *, 
			    doublecomplex *,integer *,ftnlen,ftnlen),
                     ztrmv(character *,character *,character *,integer *, 
			   doublecomplex *,integer *,doublecomplex *,integer *,
			   ftnlen,ftnlen,ftnlen),
                     zdscal(integer *,doublecomplex *,doublecomplex *,
			    integer *),
                     zhemm(character *,character *,integer *,integer *, 
			   doublecomplex *,doublecomplex *,integer *, 
			   doublecomplex *,integer *,doublecomplex *, 
			   doublecomplex *,integer *,ftnlen,ftnlen),
                     zhpr(character *,integer *,doubleprecision *,doublecomplex *,
			  integer *,doublecomplex *,ftnlen),
                     zsyrk(character *,character *,integer *,integer *, 
			   doublecomplex *,doublecomplex *,integer *,
			   doublecomplex *,doublecomplex *,integer *,ftnlen,
			   ftnlen),
                     ztrsm(character *,character *,character *,character *, 
			   integer *,integer *,doublecomplex *,doublecomplex *,
			   integer *,doublecomplex *,integer *,ftnlen,ftnlen,
			   ftnlen,ftnlen),
                     zgbmv(character *,integer *,integer *,integer *,integer *,
			   doublecomplex *,doublecomplex *,integer *, 
			   doublecomplex *,integer *,doublecomplex *, 
			   doublecomplex *,integer *,ftnlen),
                     zhemv(character *,integer *,doublecomplex *, 
			   doublecomplex *,integer *,doublecomplex *,integer *,
			   doublecomplex *,doublecomplex *,integer *,ftnlen),
                     zhpr2(character *,integer *,doublecomplex *, 
			   doublecomplex *,integer *,doublecomplex *,integer *,
			   doublecomplex *,ftnlen),
                     ztbmv(character *,character *,character *,integer *, 
			   integer *,doublecomplex *,integer *,doublecomplex *,
			   integer *,ftnlen,ftnlen,ftnlen),
                     ztrsv(character *,character *,character *,integer *, 
			   doublecomplex *,integer *,doublecomplex *,integer *,
			   ftnlen,ftnlen,ftnlen),
                     zgemm(character *,character *,integer *,integer *,
			   integer *,doublecomplex *,doublecomplex *,integer *,
			   doublecomplex *,integer *,doublecomplex *,
			   doublecomplex *,integer *,ftnlen,ftnlen),
                     zher(character *,integer *,doubleprecision *,doublecomplex *,
			  integer *,doublecomplex *,integer *,ftnlen),
                     zrot(integer *,doublecomplex *,integer *,doublecomplex *,
			  integer *,doubleprecision *,doublecomplex *),
                     zrotg(doublecomplex *,doublecomplex *,doubleprecision *,
			   doublecomplex *),
                     ztbsv(character *,character *,character *,integer *, 
			   integer *,doublecomplex *,integer *,doublecomplex *,
			   integer *,ftnlen,ftnlen,ftnlen);

integer              icamax(integer *,complex *,integer *),
                     idamax(integer *,doubleprecision *,integer *),
                     isamax(integer *,real *,integer *),
                     izamax(integer *,doublecomplex *,integer *),
                     lsame(character *,character *,ftnlen,ftnlen);
void                 xerbla(character *,integer *,ftnlen);

 
#endif /* _BLAS_H */
